*=$1A80   ;

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                Lightgun related routines
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

LIGHTGUN_INIT           LDA #%00000001          ;sprite 0-7 enable/disable register (1=enable)
                        STA $D015               ;
                        RTS                     ;

;-------------------------------------------------------------------------------
; use this routine before calling starting the actual game
;
;   JSR CALLIBRATE_LIGHTGUN
;-------------------------------------------------------------------------------

CALLIBRATE_LIGHTGUN     LDA #%00000001          ;sprite 0-7 enable/disable register (1=enable) enable the crosshair and disable all other sprites
                        STA $D015               ;
                        LDA #$3                 ;0=black, 1=white, etc.
                        STA COL_PRINT           ;set printing color
                        JSR CLEARSCREEN         ;

                        LDA #15                 ;set background and border colour
                        STA BORDER              ;poke x in 53280,x (bordercolour)
                        STA BACKGROUND          ;poke x in 53281,x (background-0)
                        LDA #0                  ;
                        STA BACKGROUND1         ;this is the color of the text (with the char we are using)
                        LDA #1                  ;green
                        STA BACKGROUND2         ;
                        LDA #11                 ;grey
                        STA BACKGROUND3         ;
              
                        LDX #0                  ;write the window that holds the diagnostic/measured values
                        LDY #0                  ;
                        JSR SET_CURSOR          ;
                        LDA #<TXT_CALL_01       ;set pointer to the text that defines the callibration-screen
                        LDY #>TXT_CALL_01       ;
                        JSR PRINT_STRING        ;the print routine is called, so the pointed text is now printed to screen     

                        LDX #0                  ;write the target to screen
                        LDY #11                 ;
                        JSR SET_CURSOR          ;
                        LDA #<TXT_CALL_02       ;set pointer to the text that defines the callibration-screen
                        LDY #>TXT_CALL_02       ;
                        JSR PRINT_STRING        ;the print routine is called, so the pointed text is now printed to screen     

                        LDX #0                  ;write the instructions
                        LDY #22                 ;
                        JSR SET_CURSOR          ;
                        LDA #<TXT_CALL_03       ;set pointer to the text that defines the callibration-screen
                        LDY #>TXT_CALL_03       ;
                        JSR PRINT_STRING        ;the print routine is called, so the pointed text is now printed to screen     

                        JMP CL_LP_02

CL_LP_01                LDA #$00                ;
                        STA LIGHTGUN_X_OFFSET   ;clear the lightguns offset value
                        STA LIGHTGUN_Y_OFFSET   ;clear the lightguns offset value
                        JSR GET_LIGHTGUN_POS    ;

                        ;calculate the offset values
                        ;---------------------------

                        LDA LIGHTGUN_RAW_X      ;
                        CLC                     ;
                        SBC #89                 ;the reference X-position
                        STA LIGHTGUN_X_OFFSET   ;

                        LDA LIGHTGUN_RAW_Y      ;
                        CLC                     ;
                        SBC #147                ;the reference Y-position
                        STA LIGHTGUN_Y_OFFSET   ;


CL_LP_02                LDX #4                  ;
                        LDY #2                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_RAW_X      ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes

                        LDX #10                 ;
                        LDY #2                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_RAW_Y      ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes

                        LDX #30                 ;
                        LDY #2                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_X_OFFSET   ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes

                        LDX #36                 ;
                        LDY #2                  ;
                        JSR SET_CURSOR          ;
                        LDA LIGHTGUN_Y_OFFSET   ;
                        JSR PRINT_DEC           ;write the value to screen for diagnostics purposes
        
                        JSR CHECK_TRIGGER       ;check if the trigger of the lightgun has been pulled
                        BCS CL_LP_01            ;use current value until the fire button has been pressed
                        JSR GET_LIGHTGUN_POS    ;
                        LDA #$0                 ;clear port to enable crude keyboard readout
                        STA $DC00               ;
                        LDA DATAPORTB           ;check keyboard inputs
                        CMP #$7F                ;STOP-key pressed?
                        BEQ CL_LP_EXIT          ;

                        JMP CL_LP_02            ;STOP-key is not pressed, keep looping

CL_LP_EXIT              RTS                     ;



TXT_CALL_01
; Screen 3 - Callibrate lightgun
        BYTE        $69,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$68,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$69,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$68
        BYTE        $66,$20,$20,$10,$0F,$13,$09,$14,$09,$0F,$0E,$20,$20,$64,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$66,$20,$20,$20,$0F,$06,$06,$13,$05,$14,$20,$20,$20,$64
        BYTE        $66,$20,$18,$3A,$2D,$2D,$20,$20,$19,$3A,$2D,$2D,$20,$64,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$66,$20,$18,$3A,$2D,$2D,$20,$20,$19,$3A,$2D,$2D,$20,$64
        BYTE        $6A,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$6B,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$6A,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$65,$6B
        BYTE 0

TXT_CALL_02
        BYTE        $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$5D,$5B,$5C,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
        BYTE        $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$5B,$5B,$5B,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
        BYTE        $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$5F,$5B,$5E,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
        BYTE 0

TXT_CALL_03  ;0123456789012345678901234567890123456789
        TEXT ' hit hammer in the center of the screen '
        TEXT '    or aim lightgun and press trigger   '
        TEXT '    use run/stop to exit this screen'
        BYTE 0





;-------------------------------------------------------------------------------
; use this routine to get the X and Y position of the lightgun
; (this requires the callibration values to be set by the CALLIBRATE_LIGHTGUN routine)
; this routine will move SPRITE-0 to the position that the lightgun points at
;
;   JSR GET_LIGHTGUN_POS
;-------------------------------------------------------------------------------

GET_LIGHTGUN_POS        LDA $D013               ;pen X
                        STA LIGHTGUN_RAW_X      ;save the current lightpen X-position
                        CLC                     ;
                        SBC LIGHTGUN_X_OFFSET   ;subtract X offset
                        PHA                     ;save result
                        CLC                     ;
                        ROL                     ;effectively multiply by two
                        STA LIGHTGUN_X          ;save the calibrated lightpen X-position
                        PLA
                        SEC                     ;
                        SBC #5                  ;the center of the crosshair is shifted ... pixels right
                        CLC                     ;
                        ROL                     ;effectively multiply by two
                        STA $D000               ;sprite-0 position X
                        BCS GLP_SPR_POS_0       ;
                        LDA $D010               ;get current value
                        AND #%11111110          ;clear 9th X-position bit of sprite 0
                        JMP GLP_SPR_POS_1       ;
GLP_SPR_POS_0           LDA $D010               ;get current value
                        ORA #%00000001          ;set 9th X-position bit of sprite 0              
GLP_SPR_POS_1           STA $D010               ;

                        LDA $D014               ;pen Y
                        STA LIGHTGUN_RAW_Y      ;save the current lightpen Y-position
                        CLC                     ;
                        SBC LIGHTGUN_Y_OFFSET   ;subtract Y offset
                        STA LIGHTGUN_Y          ;save the calibrated lightpen Y-position
                        SEC                     ;
                        SBC #8                  ;the center of the crosshair is shifted ... pixels down
                        STA $D001               ;sprite-0 position Y

                        RTS                     ;

;===================================================================
;JSR CHECK_TRIGGER      ;checks if the trigger line has been activated
;C=0 when no trigger is pulled (no trigger activity)
;C=1 when trigger is pulled (the user shoots his gun)
;===================================================================
CHECK_TRIGGER   
                ;the stack light riflle uses an simple digital IO-pin from the joystick port (port#1)
                ;check for fire button signal (raise carry if pressed) them jump to the debounce routine
                ;------------------------------------------------------------------------------------
CH_STACK        LDA $DC01                       ;
                AND #%00000100                  ;check for fire button of Stack Light Rifle
                BEQ CH_STACK_FIRE               ;trigger of Stack light rifle detected
CH_STACK_IDLE   JMP CH_MAGNUM   ;when the trigger isn't pulled, it can also be because the user is using a MAGNUM LIGHTPHAZER, so we must also check that
                ;CLC                             ;clear carry to indicate that the trigger has not been pulled
                ;JMP CH_DEBOUNCE                 ;
CH_STACK_FIRE   SEC                             ;set carry to indicate that the trigger has been pulled
                JMP CH_DEBOUNCE                 ;

                ;the magnum uses a pot-pin (analog input) from the joystick port (port #1)
                ;check for fire button signal (raise carry if pressed) them jump to the debounce routine
                ;-------------------------------------------------------------------------
CH_MAGNUM       LDA $DC00                       ;Control-Port 1 selected (bit-7=0 and bit-6=1)
                AND #%00111111                  ;clear bit-6 and bit-7
                ORA #%01000000                  ;set bit-6
                STA $DC00                       ;now control-port 1 is selected for reading the POT registers

                ;WAIT A WHILE (data aquisition time for correct measurement of analog input)
                LDX #0                          ;
TSTLP           PHA                             ;
                PLA                             ;
                DEX                             ;
                BNE TSTLP                       ;
                LDA $D41A                       ;Paddle Y value  0..255 ($D419=Paddle X value  0..255 )


;                PHA
;                LDX #0                  ;debug only (show the user where he/she is pointing)
;                LDY #0                  ;debug only
;                JSR SET_CURSOR          ;debug only
;                PLA
;                PHA
;                JSR PRINT_DEC           ;debug only
;                PLA


                CMP #128                        ;do not check for 0 or 255 but for a value below the middle (for example: this way we also support the guns that have a long cable and cannot reach value 0)
                BCC CH_MAGNUM_FIRE              ;trigger of magnum detected
CH_MAGNUM_IDLE  CLC                             ;clear carry to indicate that the trigger has not been pulled
                JMP CH_DEBOUNCE                 ;
CH_MAGNUM_FIRE  SEC                             ;set carry to indicate that the trigger has been pulled
                JMP CH_DEBOUNCE                 ;

                ;debounce the signal from the switches
                ;-------------------------------------
CH_DEBOUNCE     ROL DEBOUNCE                    ;add the value from the carry to the shift reg.
                LDA DEBOUNCE                    ;
                CMP #$FF                        ;when the entire register is filled with 1's, then we may
                BEQ CH_RESULT_FIRE              ;assume that the signal is stable and we may output the value.
CH_RESULT_IDLE  CLC                             ;clear carry to indicate that the trigger has NOT been pulled
                ;RTS                             ;return to the calling routine
                JMP CH_EDGE_DETECT              ;only detect the fire button one time, until it is released again
CH_RESULT_FIRE  SEC                             ;set carry to indicate that the trigger has been pulled
                ;RTS                             ;return to the calling routine
                ;JMP CH_EDGE_DETECT              ;only detect the fire button one time, until it is released again

                ;in order to block a continuously pressed firebutton, we need to do some edge detection on
                ;the fire button signalling, therefore we only allow this signal to be send when the previous
                ;action was "fire button not pressed". Therefore the behaviour of a long fire button press will
                ;be similar to that of a single short press.
                ;
                ;Note: for best performance call this routine as fast as possible, because it requires 8 calls to 
                ;detect a trigger press. Sometimes this takes too long (because the routine can't be called fast enough)
                ;in that case do the following in order to bypass the debouncing routine:
                ; LDA #$FF              ;filling the debounce register with $FF, disables the debouncing functionality
                ; STA DEBOUNCE          ;this way it will respond immediately when the trigger is pressed
                ; JSR CHECK_TRIGGER
                ;-----------------------------------------------------------------------------------------
CH_EDGE_DETECT  BCS CH_EDGE_D0  ;
                LDA #0          ;
                STA EDGE_DET    ;set last state to 0 (fire button not pressed)
                CLC             ;
                RTS             ;

CH_EDGE_D0      LDA EDGE_DET    ;get the last state, if this was 0 (fire button not pressed)
                BEQ CH_EDGE_D2  ;then we may generate the fire button signal
CH_EDGE_D1      CLC             ;
                RTS             ;
CH_EDGE_D2      LDA #1          ;but if the last case was 1 (fire button was already pressed)
                STA EDGE_DET    ;then we may not generate the fire button signal
                SEC             ;
                RTS

DEBOUNCE        BYTE $0 ;a simple register used as a shift register to debounce the trigger switch signal
EDGE_DET        BYTE $0 ;0 when fire button isn't pressed, 1 when fire button is pressed
