*=$1D80   ;

;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;                                 Keyboard related routines
;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

SCAN_KEYBOARD   = $FF9F         ;scans the keyboard and puts the matrix value in $C5


;-------------------------------------------------------------------------

SCAN_KEYRELEASE JSR SCAN_KEYBOARD       ;force keyboard scan
                LDA $C5                 ;matrix value of last Key pressed
                CMP #KEY_NOTHING        ;check for key
                BNE SCAN_KEYRELEASE     ;continue loop when no key is detected
                RTS

SCAN_KEYPRESS   JSR SCAN_KEYBOARD       ;because the interrups are disabled during communication with the Cassiopei, the keyboard might not be updated and therefore the buffer value remains the same, which in real life is not correct, so we execute a manual keyboard scan
                LDA $C5                 ;matrix value of last Key pressed
                RTS


;C64 keyboard scanning values

KEY_NOTHING     = $40           ;when no key is pressed
KEY_F1          = $04           ;$04 = F1 
KEY_F3          = $05           ;$05 = F3
KEY_F5          = $06           ;$06 = F5 
KEY_F7          = $03           ;$03 = F7
KEY_RETURN      = $01           ;$01 = RETURN
KEY_1           = $38           ;$38 = 1 
KEY_2           = $3B           ;$3B = 2

KEY_STACKTRIG   = $32           ;$32 = when the trigger of a stck lightgun is pulled
KEY_GUNSTICK    = $39           ;$39 = when a gunstick is connected, this value is created by the lightsensor and cannot be avoided



